import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author Edgar Silva (47987) <emda.silva@campus.fct.unl.pt>
 */
public class Main {

	public static void main(String[] args){
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String[] input;
		try{
			input = in.readLine().split(" ");

			int width = Integer.parseInt(input[0]),
				height = Integer.parseInt(input[1]);

			JackOLantern j = new JackOLantern(width, height);

			for(int i = 0; i < height; i++)
				j.addLine(in.readLine().split(" "), i);

			System.out.println(j.solve());

		}catch(IOException e){
			e.printStackTrace();
		}
	}
}
