import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {

	public static void main(String[] args){
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String[] input;
		try {
			input = in.readLine().split(" ");

			int numSuspects = Integer.parseInt(input[0]);
			SuspiciousBackpack sb = new SuspiciousBackpack(numSuspects);

			int numPreceding = Integer.parseInt(input[1]);
			int numConcurrent = Integer.parseInt(input[2]);
			for(int i = 0; i < numPreceding; i++) {
				input = in.readLine().split(" ");
				int s1 = Integer.parseInt(input[0]),
					s2 = Integer.parseInt(input[1]);
				sb.addPrecedence(s1, s2);
			}

			for(int i = 0; i < numConcurrent; i++) {
				input = in.readLine().split(" ");
				int s1 = Integer.parseInt(input[0]),
					s2 = Integer.parseInt(input[1]);
				sb.addConcurrence(s1, s2);
			}

			System.out.printf("%s conjectures\n", sb.isConsistent()? "Consistent" : "Inconsistent");

		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
